﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Quiz
{
    public partial class Quiz : Form
    {
        public Quiz()
        {
            InitializeComponent();
                       
            this.Icon = (Icon)Properties.Resources.ResourceManager.GetObject("avatar3");
         }

        private void button1_Click(object sender, EventArgs e)
        {
            int count_questions = 0;
            bool data_correct = true;
            Random randArr = new Random();
            QuizData quizData = new QuizData();
            data_correct = quizData.readData(Directory.GetCurrentDirectory() + "/questions.txt",
                Directory.GetCurrentDirectory() + "/images.txt", 
                Directory.GetCurrentDirectory() + "/answers.txt",
                Directory.GetCurrentDirectory() + "/settings.txt");

            File.WriteAllText(Directory.GetCurrentDirectory() + "/results.txt", string.Empty);

            if (data_correct) {
                count_questions = quizData.questions.Length;
                quizData.num_questions = quizData.getRandomValues(quizData.count_questions_curr, count_questions);

                Form2 question = new Form2(quizData, quizData.num_questions);
                question.richTextBox1.Text = quizData.questions[quizData.num_questions[0]];
                question.panel2.BackgroundImage = Image.FromFile(Directory.GetCurrentDirectory() + quizData.images[quizData.num_questions[0]]);
                question.radioButton1.Text = quizData.answers[quizData.num_questions[0], 0];
                question.radioButton2.Text = quizData.answers[quizData.num_questions[0], 1];
                question.radioButton3.Text = quizData.answers[quizData.num_questions[0], 2];
                question.ShowDialog();
            } else
            {
                MessageBox.Show("Число вопросов, число ответов и число картинок должно быть одинаковым!");
            }
        }

        private void aboutProgramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Автор: Присяч Глеб, 4А класс, 393 лицей");
        }

        private void settingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Settings testDialog = new Settings();
            testDialog.ShowDialog();
        }

        private void помощьToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("1. Задайте число вопросов викторины в пункте меню <<Настройки>>\n" +
                            "2. Нажмите кнопку <<Старт>>\n" +
                            "3. После выбора варианта ответа, нажмите кнопку <<Далее>>");
        }
    }

    public class QuizData
    {
        public string[] questions;
        public string[] images;
        public string[,] answers;
        public int[] num_questions;
        public int count_questions_curr;

        public QuizData() { }

        public bool readData(string questions_path, string images_path, string answers_path, string settings)
        {
            int count_questions = 0, count_images = 0, count_answers = 0;
            questions = readFileStrArr(questions_path);
            count_questions = questions.Length;
            images = readFileStrArr(images_path);
            count_images = images.Length;
            answers = readFileAnswers(answers_path);
            count_answers = answers.Length / 4;
            count_questions_curr = readSettings(settings);
            if (count_questions_curr > images.Length)
            {
                MessageBox.Show("Задано некорректное число вопросов в файле settings!");
                return false;
            }
            if ((count_questions == count_images) && (count_questions == count_answers)) return true;
            else return false;
        }

        public int readSettings(string path)
        {
            int countQuestionsValue = 0;
            if (File.Exists(path))
            {
                string[] lines = File.ReadAllLines(path);
                if (lines.Length > 1)
                    MessageBox.Show("Задано некорректное число вопросов в файле settings!");
                else
                    countQuestionsValue = Int32.Parse(lines[0]);
            }
            return countQuestionsValue;
        }
        public string[] readFileStrArr(String path)
        {
            string[] srtArr = null;
            if (File.Exists(path))
            {
                string[] lines = File.ReadAllLines(path);
                srtArr = new string[lines.Length];
                for (int i = 0; i < lines.Length; i++)
                {
                    srtArr[i] = Convert.ToString(lines[i]);
                }
            }
            return srtArr;
        }

        public string[,] readFileAnswers(String path)
        {
            string[,] answers_arr = null;
            if (File.Exists(path))
            {
                string[] lines = File.ReadAllLines(path);
                answers_arr = new string[lines.Length, lines[0].Split('#').Length];
                for (int i = 0; i < lines.Length; i++)
                {
                    string[] temp = lines[i].Split('#');
                    for (int j = 0; j < temp.Length; j++)
                        answers_arr[i, j] = Convert.ToString(temp[j]);
                }
            }
            return answers_arr;
        }

        public int[] getRandomValues(int count, int count_questions) {
            Random randArr = new Random();
            int [] num_questions_arr = Enumerable.Range(0, count_questions).OrderBy(x => randArr.Next()).Take(count).ToArray();
            return num_questions_arr;
        }
    }
}
